#!/usr/bin/env python3

from useful import *

from rtree import index

def cubeize(line):
    x, y, z, u, v, w = numbers(line)
    return (x, y, z, u + .9, v + .9, w + 1)

def icall(tree):
    ic([cube for cube in gtree.intersection((-666, -666, -666, 666, 666, 666))])

def is_supported(tree, block):
    for g in tree.intersection(block):
        if grounded[g][5] == block[2]:
            return True

def assign_touching_ground_to_ground():
    global gtree, grounded, moving
    touching = True
    while touching:
        touching = False
        for i, m in enumerate(moving):
            if is_supported(gtree, m):
                moving = np.append(moving[:i], moving[i+1:], axis=0)
                gtree.insert(len(grounded), m)
                grounded = np.append(grounded, [m, ], axis=0)
                touching = True
                break

unsortedcubes = np.asarray([cubeize(l) for l in lines(open(0))])
# sorting makes O(n²) movement closer to O(nlogn) or whatever
moving = np.asarray(sorted(unsortedcubes, key=lambda a: a[2]))

# just create the ground. max of our input happens to be 278.
grounded = np.asarray([(-666, -666, 0, 666, 666, 1)])
gtree = index.Index(properties=index.Property(dimension=3))
gtree.insert(0, grounded[0])

# also find the ones touching ground
ic(grounded, moving)
assign_touching_ground_to_ground()
ic(grounded, moving)
icall(gtree)

# drop stuff
while len(moving):
    moving += np.asarray([0, 0, -1, 0, 0, -1])
    assign_touching_ground_to_ground()
ic(grounded, moving)
icall(gtree)

# count stuff. there must be a better way.
supporting = {}
supporters = defaultdict(lambda: 0)
for i, g in enumerate(grounded):
    if i == 0: # our own fake box
        continue
    supported = [m for m in gtree.intersection(g) if grounded[m][2] > g[2]]
    supporting[i] = supported
    for s in supported:
        supporters[s] += 1
    #print('%s (%s) is resting on %s!' % (supporting, hush(supporting), i))
dprint(supporting)
ic(supporters)
print(sum(1 for k, v in supporting.items() if \
        all(supporters[vv] > 1 for vv in v)))

# part 2. basically just repeat the first part of part 1.
all_grounded = grounded
total = 0
for i, g in enumerate(all_grounded):
    if i == 0: # our own fake box
        continue
    grounded = np.asarray([(-666, -666, 0, 666, 666, 1)])
    moving = np.append(all_grounded[1:i], all_grounded[i+1:], axis=0)
    gtree = index.Index(properties=index.Property(dimension=3))
    gtree.insert(0, grounded[0])
    assign_touching_ground_to_ground()
    ic(i, len(moving))
    total += len(moving)
print(total)
